<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2005 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.2.0 - Last modified 3/18/2005
*/


// Error reporting
function print_ok() {
	global $dbconn;
	@mysql_close ($dbconn);

	header('Content-type: text/plain');
	exit ('ok');
}
function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	echo "error\n";
	exit ($exit_err);
}


// NOTE:  Cookies don't [aren't supposed to] work with POST
// Load bootstrap, quiet mode
$OekakiU    = $_GET['usr'];
$OekakiPass = $_GET['vcode'];
$quiet_mode = 1;
define ('BOOT', 1);
require ('boot.php');

// Input
$mode      = $_GET['mode'];
$edittimes = (int) $_GET['edittimes'];
$edit      = (int) $_GET['edit'];


if (empty ($OekakiU)) {
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
if (empty ($HTTP_RAW_POST_DATA)) {
	// No data to save!
	error_log (__FILE__.": No picture data to save.  User: $OekakiU");
	quiet_exit("No image data was recieved by the server.\nPlease try again, or take a screenshot of your picture.");
}


include('paintsave.php');


// Verify edit, otherwise invalidate it
$resno = verify_edit($edit);
if ($resno != 0) {
	$got_picid = 1;
} else {
	$got_picid = 0;
}


// Collect POST
$buffer = $HTTP_RAW_POST_DATA;

// Parse paint data
{
	// Get params
	$params = array ('sid'=>$_GET['sid'], 'time'=>$_GET['time']);
	$vars = array ('sid'=>1, 'time'=>1, 'uid'=>1, 'width'=>1, 'height'=>1);
	if (substr ($buffer, 0, 1) == 'P') {
		// Header
		$image['h_length'] = substr ($buffer, 1, 8);
		$image['h_length'] = (int) $image['h_length'];
		$image['h_data']   = substr ($buffer, 9, $image['h_length']);

		$a = explode(';', $image['h_data']);
		for ($i = count ($a); --$i >= 0;) {
			$b = split ('=', $a[$i]);
			if ($vars[$b[0]]) $params[$b[0]]=$b[1];
		}
	} else {
		quiet_exit("Poo compatibility with PaintBBS must be OFF!\n  Admin: set '<param name=\"poo\" value=\"false\" />'");
	}


	// PaintBBS data
	if (substr ($buffer, 0, 1) == 'P') {
		// Image data
		$image['o_length'] = substr ($buffer, $image['h_length'] + 9, 8);
		$image['o_length'] = (int) $image['o_length'];
		$image['o_data']   = substr ($buffer, $image['h_length'] + 19, $image['o_length']);

		// Animation
		$image['t_length'] = substr ($buffer, $image['h_length'] + $image['o_length'] + 19, 8);
		$image['t_length'] = (int) $image['t_length'];
		$image['t_data']   = substr ($buffer, $image['h_length'] + $image['o_length'] + 27, $image['t_length']);

		// Thumbnail
		$image['t2_length'] = substr ($buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 27, 8);
		$image['t2_length'] = (int) $image['t2_length'];
		$image['t2_data']   = substr ($buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 35, $image['t2_length']);
	}

	unset ($buffer);

	if (!$image['o_data']) {
		error_log (__FILE__.": No image data.  User: $OekakiU");
		quiet_exit("No data was received!  Take a screenshot of your picture (to be safe), and try submitting it again.");
	}
}


// Secure a new pic number if needed
if ($resno == 0) {
	$resno = get_new_picnumber();
}
if ($resno == 0) {
	error_log (__FILE__.": Cannot allocate new PIC_ID.  User: $OekakiU");
	quiet_exit("Unable to allocate a new picture slot!\nTake a screenshot of your picture and tell the admin.");
}


// Insert new slot into database

if ($mode == 'norm' || $mode == 'anim') {
	// Remove old slot
	$result = kill_picnumber($resno);

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', PIC_ID='$resno', IP='$address', datatype=0, edittime='$thetime'";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);


		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
		quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($image['o_data'], $resno)) {
	error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
	quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
}
if (!empty ($image['t_data'])) {
	if (!save_anim($image['t_data'], $resno, 'pch')) {
		error_log (__FILE__.": Cannot save anim.  Look for temp image.  User: $OekakiU, Number: $resno, Extension: .pch");
	}
}

print_ok();

?>